﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Collections;

namespace Prova1
{
    class EventsGenerator
    {
        private readonly XmlDocument _document;
        private IEnumerator _nodeEnumerator;

        public event WorkEventHandler WorkArrival;

        public EventsGenerator(string fileName)
        {
            _document = new XmlDocument();
            _document.Load(fileName);
            _nodeEnumerator = _document.DocumentElement.ChildNodes.GetEnumerator();
        }

        public int Workers
        {
            get { return XmlConvert.ToInt32(_document.DocumentElement.GetAttribute("workers")); }
        }

        public int Pulses
        {
            get { return XmlConvert.ToInt32(_document.DocumentElement.GetAttribute("pulses")); }
        }

        public void Pulse()
        {
            XmlElement xmlEvent = NextXmlEvent();
            if (xmlEvent.Name == "WorkArrival")
            {
                int duration = XmlConvert.ToInt32(xmlEvent.GetAttribute("duration"));
                Work work = new Work(duration);
                OnWorkArrival(work);
            }
        }

        protected XmlElement NextXmlEvent()
        {
            if (_nodeEnumerator.MoveNext())
            {
                return (XmlElement) _nodeEnumerator.Current;
            }
            else
            {
                _nodeEnumerator.Reset();
                return NextXmlEvent();
            }
        }

        protected void OnWorkArrival(Work work)
        {
            if (WorkArrival != null)
                WorkArrival(this, work);
        }
    }
}
