﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace Prova1
{
    class Logger
    {
        private XmlTextWriter _writer;

        public Logger()
        {
        }

        public void Start(string fileName)
        {
            _writer = new XmlTextWriter(fileName, Encoding.UTF8);
            _writer.Formatting = Formatting.Indented;
            _writer.WriteStartDocument();
            _writer.WriteStartElement("Simulation");
        }

        public void End()
        {
            _writer.WriteEndElement();  //  Simulation
            _writer.WriteEndDocument();
            _writer.Close();
            _writer = null;
        }

        //  <Pulse pulseId="1">
        public void StartPulse(int pulseId)
        {
            _writer.WriteStartElement("Pulse");
            _writer.WriteAttributeString("pulseId", XmlConvert.ToString(pulseId));
        }

        //  <WorkQueueState>
        //    <Work workId="9" duration="16" />
        //  </WorkQueueState>
        //</Pulse>
        public void EndPulse(WorkQueue workQueue)
        {
            _writer.WriteStartElement("WorkQueueState");
            foreach (Work work in workQueue)
            {
                _writer.WriteStartElement("Work");
                _writer.WriteAttributeString("workId", XmlConvert.ToString(work.Id));
                _writer.WriteAttributeString("duration", XmlConvert.ToString(work.Duration));
                _writer.WriteEndElement();  //  Work
            }
            _writer.WriteEndElement();  //  WorkQueueState
            _writer.WriteEndElement();  //  Pulse
        }

        //  <WorkStarted workerId="1" workId="1" duration="10" />
        public void WorkStartedHandler(object source, Work work)
        {
            Worker worker = (Worker) source;
            _writer.WriteStartElement("WorkStarted");
            _writer.WriteAttributeString("workerId", XmlConvert.ToString(worker.Id));
            _writer.WriteAttributeString("workId", XmlConvert.ToString(work.Id));
            _writer.WriteAttributeString("duration", XmlConvert.ToString(work.Duration));
            _writer.WriteEndElement();  //  WorkStarted
        }

        //  <WorkDone workerId="1" workId="1" />
        public void WorkDoneHandler(object source, Work work)
        {
            Worker worker = (Worker) source;
            _writer.WriteStartElement("WorkDone");
            _writer.WriteAttributeString("workerId", XmlConvert.ToString(worker.Id));
            _writer.WriteAttributeString("workId", XmlConvert.ToString(work.Id));
            _writer.WriteEndElement();  //  WorkDone
        }

        //  <Enqueued workId="1" duration="10" />
        public void EnqueuedHandler(object source, Work work)
        {
            _writer.WriteStartElement("Enqueued");
            _writer.WriteAttributeString("workId", XmlConvert.ToString(work.Id));
            _writer.WriteAttributeString("duration", XmlConvert.ToString(work.Duration));
            _writer.WriteEndElement();  //  Enqueued
        }

        //  <Dequeued workId="1" duration="10" />
        public void DequeuedHandler(object source, Work work)
        {
            _writer.WriteStartElement("Dequeued");
            _writer.WriteAttributeString("workId", XmlConvert.ToString(work.Id));
            _writer.WriteAttributeString("duration", XmlConvert.ToString(work.Duration));
            _writer.WriteEndElement();  //  Dequeued
        }
    }
}
