﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prova1
{
    class Program
    {
        static WorkQueue _workQueue = new WorkQueue();

        static void Main(string[] args)
        {
            Logger logger = new Logger();
            _workQueue.Enqueued += logger.EnqueuedHandler;
            _workQueue.Dequeued += logger.DequeuedHandler;

            EventsGenerator eventsGenerator = new EventsGenerator("../../Input.xml");
            eventsGenerator.WorkArrival += new WorkEventHandler(eventsGenerator_WorkArrival);

            List<Worker> workers = new List<Worker>();
            for (int workId = 1; workId <= eventsGenerator.Workers; workId++)
            {
                Worker worker = new Worker();
                workers.Add(worker);
                worker.WorkStarted += logger.WorkStartedHandler;
                worker.WorkDone += logger.WorkDoneHandler;
                worker.Idle += new WorkEventHandler(worker_Idle);
            }

            logger.Start("../../Output.xml");
            for (int pulseId = 1; pulseId <= eventsGenerator.Pulses; pulseId++)
            {
                logger.StartPulse(pulseId);
                eventsGenerator.Pulse();
                foreach (Worker worker in workers)
                {
                    worker.Pulse();
                }
                logger.EndPulse(_workQueue);
            }
            logger.End();
        }

        static void worker_Idle(object source, Work work)
        {
            if (!(source is Worker))
                throw new ArgumentException("!(source is Worker)");
            if (_workQueue.Count > 0)
            {
                Worker worker = (Worker) source;
                worker.Assign(_workQueue.Dequeue());
            }
        }

        static void eventsGenerator_WorkArrival(object source, Work work)
        {
            _workQueue.Enqueue(work);
        }
    }
}
