﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prova1
{
    delegate void WorkEventHandler(object source, Work work);

    class Work
    {
        private readonly int _id;
        private int _duration;

        private static int _nextId = 1;

        public Work(int duration)
        {
            if (duration <= 0)
                throw new ArgumentException("duration <= 0");
            _id = _nextId++;
            _duration = duration;
        }

        public int Id
        {
            get { return _id; }
        }

        public int Duration
        {
            get { return _duration; }
            private set { _duration = value; }
        }

        public bool Done
        {
            get { return (Duration == 0); }
        }

        public void Do()
        {
            if (Done)
                throw new ApplicationException("Done");
            Duration--;
        }
    }
}
